#pragma once

#include "ofMain.h"

extern "C" 
{
	#include "bcm_host.h"
	#include "ilclient.h"
	#include "IL/OMX_Core.h"
};


class testApp : public ofBaseApp {
	
public:
	void setup();
	void update();
	void draw();
	
	void exit();

	void keyPressed(int key);
	void keyReleased(int key);
	void mouseMoved(int x, int y );
	void mouseDragged(int x, int y, int button);
	void mousePressed(int x, int y, int button);
	void mouseReleased(int x, int y, int button);
	void windowResized(int w, int h);
	void dragEvent(ofDragInfo dragInfo);
	void gotMessage(ofMessage msg);		
	ILCLIENT_T* client;
	OMX_VIDEO_PARAM_PORTFORMATTYPE format;
	OMX_TIME_CONFIG_CLOCKSTATETYPE cstate;
	COMPONENT_T *video_decode;
	COMPONENT_T *video_scheduler;
	COMPONENT_T *video_render;
	COMPONENT_T *clock;
	COMPONENT_T *list[5];
	TUNNEL_T tunnel[4];
	
	unsigned char *data;
	unsigned int data_len;
	int find_start_codes;
	int packet_size; 
	//int initOMXVideo();
	static void onEmptyBufferDone(void* args, COMPONENT_T* component);
	bool isVideoReady;
	
	int status;
	OMX_BUFFERHEADERTYPE *buf;
	int port_settings_changed;
	int first_packet;
	unsigned char *dest;
	FILE *in;
	//void emptyBuffer();
	ofImage overlay;
};

